package tools.descartes.dql.connector.simQPN;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.FileLocator;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import tools.descartes.dql.core.engine.util.DQLLogger;

public class FileUtil {
	private static final Logger log = DQLLogger.getLogger(FileUtil.class.getName());
	private static boolean checked = false;
	private static boolean weird = false;
	
	public static String getPath(String name) {
		URL url = FileUtil.class.getClassLoader().getResource(name);
		if (url.toString().contains("bundleresource:"))
			try {
				url = FileLocator.resolve(url);
			} catch (IOException e) {
				log.error("couldn't resolve the URL:" + url.toString());
			}
		File modelPath = null;
			try {
				modelPath = new File(url.toURI());
			} catch (URISyntaxException e) {
				log.error("UriSyntaxException " + e.getMessage());
				throw new DQLException("A internal error occured while trying to get the"
						+ "path of a file!");
			}
		return getURL(modelPath);
	}
	
	public static Document loadDocument(File document) {
		try {
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = null;
				dBuilder = dbFactory.newDocumentBuilder();
			Document doc = null;
				doc = dBuilder.parse(document);
			doc.getDocumentElement().normalize();
			return doc;
		} catch (SAXException | IOException | ParserConfigurationException e) {
			log.error("Couldn't load document");
			throw new DQLException("Couldn't load document");
		}
	}
	
	public static String getURL(File f) {
		if (!checked)
			check();
		if (weird)
			return f.toURI().toString();
		return f.getAbsolutePath();
	}

	private static void check() {
		File f = new File("test.xml");
		try {
			f.createNewFile();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		try {
			new FileInputStream(f.getAbsolutePath());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			weird = true;
		}
		checked = true;
	}
	
	public static File createFile(String filePath) {
		File f = new File(filePath);
		try {
			f.createNewFile();
		} catch (IOException e) {
			log.error("Was unable to create required Folders/Files!");
			log.error(e.getMessage());
		}
		return f;
	}
	
	public static String getNameOfFile(String filePath) {
		return filePath.substring(filePath.lastIndexOf(File.separator) + 1);
	}
}
