package tools.descartes.dql.connector.simQPN;

import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.Collection;

import org.dom4j.Element;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameter;
import org.junit.runners.Parameterized.Parameters;

import tools.descartes.dql.connector.simQPN.NetUtil;
import tools.descartes.dql.connector.simQPN.testUtils.TestUtil;

/*
 * This test checks if the model is correctly imported as a Element
 * To do this it loads the xml as a Element and compares the Element's
 * .toXML.toString() to the actual content of the file
 */

@RunWith(Parameterized.class)
public class NetUtilTest {
    @Parameters
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][] {     
                 { "ispass03.qpe" }, 
                 { "SPECjms2007Model.qpe" } 
           });
    }

    @Parameter
    public String path;
    
	@Test
	public void test() {
		String modelPath = FileUtil.getPath(path);
		
		Element net = NetUtil.loadXmlFromFile(modelPath);       
		String result = net.asXML().toString();
		
		assertTrue(TestUtil.contentCompare(prepareString(TestUtil.loadFromFile(modelPath)), result));
	}
	
	private String prepareString(String xml) {
		return xml.substring(xml.indexOf("<net"));
	}
}
