package tools.descartes.dql.connector.simQPNV2;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.SAXReader;
import org.dom4j.io.XMLWriter;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;

import de.tud.cs.qpe.model.NetHelper;
import de.tud.cs.qpe.model.PlaceHelper;

public class NetUtil {
	
	public static void save(File path, Element doc) {
        XMLWriter writer = null;
        try {
            OutputFormat format = OutputFormat.createPrettyPrint();
            writer = new XMLWriter(new FileOutputStream(path), format);
            writer.write(doc);
        } catch (IOException e) {
        } finally {
            if (writer != null) {
                try {
                    writer.close();
                } catch (IOException e) {
                }
            }
        }
    }
	
	public static String getIdOfElement(Element e) {
		return e.attributeValue(new org.dom4j.QName("id"));
	}
	
	public static String getPlaceContainingQueue(Element net, String queueId) {
		try {
			Element place = (Element)net.selectSingleNode("//net/places/place[@queue-ref=\""
								+ queueId + "\"]");
			return getIdOfElement(place);
		} catch(Exception e) {
			throw new DQLException("The queue with the id " + queueId 
					+ " is not used in any places");
		}
	}
	
	public static List<Element> getColorsForPlace(Element place) {
		List<Element> colors = new LinkedList<Element>();
		for (Element color: PlaceHelper.listVisibleColors(place))
			if (PlaceHelper.existsColorReferenceForColorId(place,
					NetUtil.getIdOfElement(color)))
				colors.add(color);
		return colors;
	}
	
	public static List<Element> getColorReferencesForPlace(Element place) {
		List<Element> refs = new LinkedList<Element>();
		for (Object o: place.selectNodes("color-refs/color-ref"))
			refs.add((Element)o);
		return refs;
	}
		
	public static String getNameOfElement(Element e) {
		return e.attributeValue(new org.dom4j.QName("name"));
	}
}
